var options = {
  series: [
    {
      name: '2020',
      data: [
        {
          x: 'Data engineer',
          y: 96,
        },
        {
          x: 'Backend',
          y: 92,
        },
        {
          x: 'Mobile',
          y: 88,
        },
        {
          x: 'Frontend',
          y: 84,
        },
        {
          x: 'QA',
          y: 71,
        },
      ],
    },
    {
      name: '2025',
      data: [
        {
          x: 'Data engineer',
          y: 148,
        },
        {
          x: 'Backend',
          y: 137,
        },
        {
          x: 'Mobile',
          y: 121,
        },
        {
          x: 'Frontend',
          y: 126,
        },
        {
          x: 'QA',
          y: 99,
        },
      ],
    },
  ],
  chart: {
    type: 'dumbbell',
    height: 380,
  },
  colors: ['#3B82F6', '#EF4444'],
  title: {
    text: 'Median base salary by role',
    align: 'left',
  },
  subtitle: {
    text: 'Illustrative data. The dot is the year, the bar is the gap.',
    align: 'left',
  },
  xaxis: {
    labels: {
      formatter: function (val) {
        return '$' + Math.round(val) + 'k'
      },
    },
  },
  grid: {
    xaxis: {
      lines: {
        show: true,
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Basic Dumbbell in Angular

Using ApexCharts with Angular

This Basic Dumbbell example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

import 'apexcharts/features/dumbbell';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: '2020',
              data: [
                {
                  x: 'Data engineer',
                  y: 96,
                },
                {
                  x: 'Backend',
                  y: 92,
                },
                {
                  x: 'Mobile',
                  y: 88,
                },
                {
                  x: 'Frontend',
                  y: 84,
                },
                {
                  x: 'QA',
                  y: 71,
                },
              ],
            },
            {
              name: '2025',
              data: [
                {
                  x: 'Data engineer',
                  y: 148,
                },
                {
                  x: 'Backend',
                  y: 137,
                },
                {
                  x: 'Mobile',
                  y: 121,
                },
                {
                  x: 'Frontend',
                  y: 126,
                },
                {
                  x: 'QA',
                  y: 99,
                },
              ],
            },
          ],
          chart: {
            type: 'dumbbell',
            height: 380,
          },
          colors: ['#3B82F6', '#EF4444'],
          title: {
            text: 'Median base salary by role',
            align: 'left',
          },
          subtitle: {
            text: 'Illustrative data. The dot is the year, the bar is the gap.',
            align: 'left',
          },
          xaxis: {
            labels: {
              formatter: (val) => {
                return '$' + Math.round(val) + 'k'
              },
            },
          },
          grid: {
            xaxis: {
              lines: {
                show: true,
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Basic Dumbbell in Vue

Using ApexCharts with Vue

This Basic Dumbbell example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="dumbbell"
        height="380"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/dumbbell'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: '2020',
          data: [
            {
              x: 'Data engineer',
              y: 96,
            },
            {
              x: 'Backend',
              y: 92,
            },
            {
              x: 'Mobile',
              y: 88,
            },
            {
              x: 'Frontend',
              y: 84,
            },
            {
              x: 'QA',
              y: 71,
            },
          ],
        },
        {
          name: '2025',
          data: [
            {
              x: 'Data engineer',
              y: 148,
            },
            {
              x: 'Backend',
              y: 137,
            },
            {
              x: 'Mobile',
              y: 121,
            },
            {
              x: 'Frontend',
              y: 126,
            },
            {
              x: 'QA',
              y: 99,
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'dumbbell',
          height: 380,
        },
        colors: ['#3B82F6', '#EF4444'],
        title: {
          text: 'Median base salary by role',
          align: 'left',
        },
        subtitle: {
          text: 'Illustrative data. The dot is the year, the bar is the gap.',
          align: 'left',
        },
        xaxis: {
          labels: {
            formatter: function (val) {
              return '$' + Math.round(val) + 'k'
            },
          },
        },
        grid: {
          xaxis: {
            lines: {
              show: true,
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Basic Dumbbell in React

Using ApexCharts with React

This Basic Dumbbell example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/dumbbell'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: '2020',
        data: [
          {
            x: 'Data engineer',
            y: 96,
          },
          {
            x: 'Backend',
            y: 92,
          },
          {
            x: 'Mobile',
            y: 88,
          },
          {
            x: 'Frontend',
            y: 84,
          },
          {
            x: 'QA',
            y: 71,
          },
        ],
      },
      {
        name: '2025',
        data: [
          {
            x: 'Data engineer',
            y: 148,
          },
          {
            x: 'Backend',
            y: 137,
          },
          {
            x: 'Mobile',
            y: 121,
          },
          {
            x: 'Frontend',
            y: 126,
          },
          {
            x: 'QA',
            y: 99,
          },
        ],
      },
    ],
    options: {
      chart: {
        type: 'dumbbell',
        height: 380,
      },
      colors: ['#3B82F6', '#EF4444'],
      title: {
        text: 'Median base salary by role',
        align: 'left',
      },
      subtitle: {
        text: 'Illustrative data. The dot is the year, the bar is the gap.',
        align: 'left',
      },
      xaxis: {
        labels: {
          formatter: function (val) {
            return '$' + Math.round(val) + 'k'
          },
        },
      },
      grid: {
        xaxis: {
          lines: {
            show: true,
          },
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="dumbbell"
          height={380}
        />
      </div>
    </div>
  )
}

export default ApexChart